<template>
  <div class="app-container">
    <el-table
      v-loading="loading"
      :data="reservesList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column label="开采量体积" align="center" prop="kaicaitj" />
      <el-table-column label="开采量重量" align="center" prop="kaicaizl" />
      <el-table-column label="保有量体积" align="center" prop="baoyoutj" />
      <el-table-column label="保有量重量" align="center" prop="baoyouzl" />
      <el-table-column label="可利用量体积" align="center" prop="keliyongtj" />
      <el-table-column label="可利用量重量" align="center" prop="keliyongzl" />
      <el-table-column label="可利用量重量" align="center" prop="keliyongzl" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:reserves:edit']"
            >编辑</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改储量信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="开采体积" prop="kaicaitj">
          <el-input v-model="form.kaicaitj" placeholder="请输入开采量体积" />
        </el-form-item>
        <el-form-item label="开采重量" prop="kaicaizl">
          <el-input v-model="form.kaicaizl" placeholder="请输入开采量重量" />
        </el-form-item>
        <el-form-item label="保有体积" prop="baoyoutj">
          <el-input v-model="form.baoyoutj" placeholder="请输入保有量体积" />
        </el-form-item>
        <el-form-item label="保有重量" prop="baoyouzl">
          <el-input v-model="form.baoyouzl" placeholder="请输入保有量重量" />
        </el-form-item>
        <el-form-item label="可利用体积" prop="keliyongtj">
          <el-input v-model="form.keliyongtj" placeholder="请输入可利用体积" />
        </el-form-item>
        <el-form-item label="可利用重量" prop="keliyongzl">
          <el-input v-model="form.keliyongzl" placeholder="请输入可利用重量" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listReserves,
  getReserves,
  delReserves,
  addReserves,
  updateReserves,
} from "@/api/reSave/reserves";

export default {
  name: "Reserves",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 储量信息表格数据
      reservesList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        kaicaitj: null,
        kaicaizl: null,
        baoyoutj: null,
        baoyouzl: null,
        keliyongtj: null,
        keliyongzl: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        kaicaitj: [
          { required: true, message: "开采量体积不能为空", trigger: "blur" },
        ],
        kaicaizl: [
          { required: true, message: "开采量重量不能为空", trigger: "blur" },
        ],
        baoyoutj: [
          { required: true, message: "保有量体积不能为空", trigger: "blur" },
        ],
        baoyouzl: [
          { required: true, message: "保有量重量不能为空", trigger: "blur" },
        ],
        keliyongtj: [
          { required: true, message: "可利用体积不能为空", trigger: "blur" },
        ],
        keliyongzl: [
          { required: true, message: "可利用重量不能为空", trigger: "blur" },
        ],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询储量信息列表 */
    getList() {
      this.loading = true;
      listReserves(this.queryParams).then((response) => {
        this.reservesList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        kaicaitj: null,
        kaicaizl: null,
        baoyoutj: null,
        baoyouzl: null,
        keliyongtj: null,
        keliyongzl: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加储量信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getReserves(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改储量信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateReserves(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addReserves(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除储量信息编号为"' + ids + '"的数据项？')
        .then(function () {
          return delReserves(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "system/reserves/export",
        {
          ...this.queryParams,
        },
        `reserves_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
